#!/bin/sh

if [[ $LSBDBPASSWD ]]
then
        passwd_option="-p$LSBDBPASSWD"
fi

MAX_LSB_VERSION=`mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT MAX(LVvalue) FROM LSBVersion" | grep -v MAX`

echo > appearance_check.out

cat appearance_fields | while read table1 id_field1 table2 id_field2
do
	table1_clear=`echo $table1 | cut -f1 -d_`
	table1_joins=`echo $table1 | cut -f2- -d_ | sed s/_/\ /g`
	table1=$table1_clear
        prefix1=`echo $table1 | sed s/[[\:lower\:]]//g`
        prefix2=`echo $table2 | sed s/[[\:lower\:]]//g`
        # Ugh, RpmTag doesn't follow general naming conventions...
        if [[ $table1 = "RpmTag" ]]
        then
                prefix1="R"
        fi
        if [[ $table2 = "RpmTag" ]]
        then
                prefix2="R"
        fi
        field_appeared1="${prefix1}appearedin"
        field_withdrawn1="${prefix1}withdrawnin"
        field_appeared2="${prefix2}appearedin"
        field_withdrawn2="${prefix2}withdrawnin"
	
	mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT DISTINCT $id_field1, $field_appeared1, $field_withdrawn1 \
		 FROM $table1 $table1_joins WHERE $field_appeared1 > ''" | grep -v appearedin | while read table_id appeared withdrawn
	do
		echo $table_id $appeared
		if [[ $withdrawn = "NULL" ]]
		then
		    max=$MAX_LSB_VERSION
		else 
		    max=`mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT MAX(LVvalue) FROM LSBVersion WHERE LVvalue<'$withdrawn'" | grep -v LVvalue`
		fi
		
		mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT LVvalue FROM LSBVersion \
			WHERE LVvalue>= '2.0' AND LVvalue BETWEEN '$appeared' AND '$max'" | grep -v LVvalue | while read version
		do
			echo $version
			detect=`mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT $id_field2 FROM $table2 WHERE $id_field2=$table_id \
				    AND $field_appeared2 > '' AND $field_appeared2 <= '$version'
				    AND ($field_withdrawn2 IS NULL OR $field_withdrawn2 > '$version') LIMIT 1" | grep -v $id_field2`
			if [[ $detect != $table_id ]]
			then
				echo "Appearance: $table1.$id_field1 = $table_id is marked as included in LSB $version, but $table2 doesn't have appropriate record for $id_field2" >> appearance_check.out
			fi
		done
	done
done

sort -u appearance_check.out > appearance_check.out.tmp && mv appearance_check.out.tmp appearance_check.out
