#!/usr/bin/perl -w

use strict;
use Getopt::Long;
use DBI;
use Text::Wrap;
use Shell qw(basename); # Assuming this script is going to run on Linux
Getopt::Long::Configure ("posix_default", "no_ignore_case");

use Env qw(LSBUSER LSBDBPASSWD LSBDB LSBDBHOST);

# Options
my $DBName = $LSBDB;
my $DBUser = $LSBUSER;
my $DBPass = $LSBDBPASSWD;
my $DBHost = $LSBDBHOST;

if(@ARGV != 1) {
    print "Usage: $0 app_name|app_id\n";
    exit 1;
}

my $dbh;
if( $DBPass ) {
        $dbh = DBI->connect('DBI:mysql:database='.$DBName.';host='.$DBHost, $DBUser, $DBPass)
        or die "Couldn't connect to database: " . DBI->errstr;
}
else {
        $dbh = DBI->connect('DBI:mysql:database='.$DBName.';host='.$DBHost, $DBUser)
        or die "Couldn't connect to database: " . DBI->errstr;
}

my $Aid=0;

if( $ARGV[0] =~ /^\d+$/ ) {
    $Aid = $ARGV[0];
}
else {
    my $app_Q = $dbh->prepare('select * from Application where Aname = ? ' ) or die();
    $app_Q->execute( $ARGV[0] );
    if( $app_Q->rows != 1 ) {
	print "Can't find unique record for application ".$ARGV[0]."\n";
	exit 1;
    }
    ($Aid) = $app_Q->fetchrow_array();
}


$dbh->do("delete from Application where Aid=$Aid");
$dbh->do("delete from AppInterpreter where AIaid=$Aid");
$dbh->do("delete from AppCategory where ACaid=$Aid");
$dbh->do("delete from AppLib where ALaid=$Aid");
#$dbh->do("delete from AppJInt where AJIaid=$Aid");
$dbh->do("delete from AppRInt where ARIaid=$Aid");
$dbh->do("delete from AppRILM where ARMaid=$Aid");
$dbh->do("delete from cache_AppRIntLib where ARIaid=$Aid");
$dbh->do("delete from cache_AppLibUsage where Aid=$Aid");
$dbh->do("delete from AppInfo where AIname not in (select distinct Aname from Application)");
