#!/bin/bash

for i in *sql
do
    if [[ -e ${i%sql}init ]]
    then
        cat $i | grep -v '  KEY' | grep -v '  UNIQUE KEY' | grep -v '  FULLTEXT KEY' | sed 's/PRIMARY\(.*\),$/PRIMARY\1/' > ${i}.new
        grep KEY $i | grep -v PRIMARY | grep -v '/\*' | while read k
        do
            kname=`echo $k | rev | cut -f2 -d\  |rev `
            kcols=`echo $k | rev | cut -f1 -d\  |rev `
            unique=`echo $k | grep UNIQUE | cut -f1 -d\  `
            echo "create $unique index \"${i%.sql}_${kname/\"/} on \"${i%.sql}\" ${kcols%,};" >> ${i}.new
        done
        sed -i 's/tinyint(4) unsigned/smallint/' ${i}.new
        sed -i 's/tinyint(4)/smallint/' ${i}.new
        sed -i 's/tinyint(1)/smallint/' ${i}.new
        sed -i 's/smallint(6)/smallint/' ${i}.new
        sed -i 's/int(10) unsigned/integer/' ${i}.new
        sed -i 's/int(10)/integer/' ${i}.new
        sed -i 's/int(8)/integer/' ${i}.new
        sed -i 's/bigint(20) unsigned/numeric(20)/' ${i}.new
        sed -i 's/bigint(20)/bigint/' ${i}.new
        sed -i 's/int(12) unsigned/integer/' ${i}.new
        sed -i 's/int(12)/integer/' ${i}.new
        sed -i 's/int(2) unsigned/integer/' ${i}.new
        sed -i 's/int(11)/integer/' ${i}.new
        sed -i 's/blob/bytea/' ${i}.new
        sed -i 's/"HGdescription"(400)/"HGdescription"/' ${i}.new
        sed -i 's/"AAvalue"(20)/"AAvalue"/' ${i}.new
        sed -i 's/"Iunmangled"(1000)/"Iunmangled"/' ${i}.new
        sed -i 's/"STvalue" integer/"STvalue" bigint/' ${i}.new
        sed -i 's/"CIunmangled"(1000)/"CIunmangled"/' ${i}.new
        sed -i 's/"RIunmangled"(1000)/"RIunmangled"/' ${i}.new
        sed -i 's/"RCname"(1000)/"RCname"/' ${i}.new
        sed -i 's/"STname"(20)/"STname"/' ${i}.new
        sed -i 's/CHARACTER SET latin1 COLLATE latin1_bin//' ${i}.new
        sed -i 's/"\(.*\)" enum(\(.*\))\(.*\),$/"\1" varchar(255)\3 CONSTRAINT k1 CHECK ("\1" in (\2,'\'\'')),/' ${i}.new
        mv ${i}.new ${i}
    fi

    sed -i 's/k1 CHECK ("ACui"/k2 CHECK ("ACui"/' AppCategory.sql
    sed -i 's/k1 CHECK ("ACsize"/k3 CHECK ("ACsize"/' AppCategory.sql
    sed -i 's/k1 CHECK ("ACcategory"/k4 CHECK ("ACcategory"/' AppCategory.sql
    sed -i 's/k1 CHECK ("Ctested"/k2 CHECK ("Ctested"/' Command.sql
    sed -i 's/k1 CHECK ("Cbuiltin"/k3 CHECK ("Cbuiltin"/' Command.sql
    sed -i 's/k1 CHECK ("CIvtclass"/k2 CHECK ("CIvtclass"/' ClassInfo.sql
    sed -i 's/k1 CHECK ("Idocumented"/k2 CHECK ("Idocumented"/' Interface.sql
    sed -i 's/k1 CHECK ("Isrcbin"/k3 CHECK ("Isrcbin"/' Interface.sql
    sed -i 's/k1 CHECK ("Istatic"/k4 CHECK ("Istatic"/' Interface.sql
    sed -i 's/k1 CHECK ("Ivirtual"/k5 CHECK ("Ivirtual"/' Interface.sql
    sed -i 's/k1 CHECK ("Iaccess"/k6 CHECK ("Iaccess"/' Interface.sql
    sed -i 's/k1 CHECK ("Ifkind"/k7 CHECK ("Ifkind"/' Interface.sql
    sed -i 's/k1 CHECK ("Icharge"/k8 CHECK ("Icharge"/' Interface.sql
    sed -i 's/k1 CHECK ("Itestable"/k9 CHECK ("Itestable"/' Interface.sql
    sed -i 's/k1 CHECK ("Ithrow"/k10 CHECK ("Ithrow"/' Interface.sql
    sed -i 's/k1 CHECK ("JCaccess"/k2 CHECK ("JCaccess"/' JavaClass.sql
    sed -i 's/k1 CHECK ("JCabstract"/k3 CHECK ("JCabstract"/' JavaClass.sql
    sed -i 's/k1 CHECK ("JCinterface"/k4 CHECK ("JCinterface"/' JavaClass.sql
    sed -i 's/k1 CHECK ("JIaccess"/k3 CHECK ("JIaccess"/' JavaInterface.sql
    sed -i 's/k1 CHECK ("JIstatic"/k4 CHECK ("JIstatic"/' JavaInterface.sql
    sed -i 's/k1 CHECK ("JIsynchronized"/k5 CHECK ("JIsynchronized"/' JavaInterface.sql
    sed -i 's/k1 CHECK ("JIfinal"/k6 CHECK ("JIfinal"/' JavaInterface.sql
    sed -i 's/k1 CHECK ("JIabstract"/k2 CHECK ("JIabstract"/' JavaInterface.sql
    sed -i 's/k1 CHECK ("Rgroup"/k2 CHECK ("Rgroup"/' RpmTag.sql
    sed -i 's/k1 CHECK ("Rstatus"/k3 CHECK ("Rstatus"/' RpmTag.sql
    sed -i 's/k1 CHECK ("SEdocumented"/k3 CHECK ("SEdocumented"/' SourceEntity.sql
    sed -i 's/k1 CHECK ("SSkind"/k3 CHECK ("SSkind"/' SourceShadow.sql
    sed -i 's/k1 CHECK ("Tsrconly"/k2 CHECK ("Tsrconly"/' Type.sql
    sed -i 's/k1 CHECK ("Tconly"/k3 CHECK ("Tconly"/' Type.sql
    sed -i 's/k1 CHECK ("Tindirect"/k4 CHECK ("Tindirect"/' Type.sql

    sed -i 's/k1 CHECK ("FTstatus"/k2 CHECK ("FTstatus"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTlicense"/k3 CHECK ("FTlicense"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTstable"/k4 CHECK ("FTstable"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTbestpractice"/k5 CHECK ("FTbestpractice"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTrationale"/k6 CHECK ("FTrationale"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTsample"/k7 CHECK ("FTsample"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTappbat"/k8 CHECK ("FTappbat"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTdemand"/k9 CHECK ("FTdemand"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTdepends"/k10 CHECK ("FTdepends"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTupstream"/k11 CHECK ("FTupstream"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTdistros"/k12 CHECK ("FTdistros"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTversions"/k13 CHECK ("FTversions"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTpatches"/k14 CHECK ("FTpatches"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTdb"/k15 CHECK ("FTdb"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTspec"/k16 CHECK ("FTspec"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTtest"/k17 CHECK ("FTtest"/' FutureTarget.sql
    sed -i 's/k1 CHECK ("FTdevel"/k18 CHECK ("FTdevel"/' FutureTarget.sql
done

for i in *sql
do
    if [[ -e ${i%sql}init ]]
    then
        cat $i | tr -d '"' > ${i}.new
        mv ${i}.new ${i}
        table=${i%.sql}
        cat ${i%sql}init | sed "s/\"${i%.sql}\"/${table}/" > ${i}.new
        mv ${i}.new ${i%sql}init
    fi
done
