#!/bin/sh

rm -rf downloaded_pages
mkdir downloaded_pages
rm -f erroneous_urls

if [[ $LSBDBPASSWD ]]
then
        passwd_option="-p$LSBDBPASSWD"
fi

# Note: we currently ignore anchors in cxxabi.html due to its incorrect layout
# We also don't check arch-specific LSB urls
mysql $LSBDB -u $LSBUSER $passwd_option -e "SELECT concat(Sbaselink,'/',ISurl), ISurl 
		FROM IntStd JOIN Standard ON Sid=ISsid 
		WHERE ISurl > '' 
		AND ISurl NOT LIKE '%cxxabi%' 
		AND ISurl NOT LIKE '%\$arch%'
		AND ISwithdrawnin IS NULL 
		UNION 
		SELECT replace(concat(Sbaselink,'/',CSurl),'functions','utilities'), CSurl AS ISurl
		FROM CmdStd JOIN Standard ON Sid=CSsid 
		WHERE CSurl > '' 
		AND CSwithdrawnin IS NULL" | grep -v NULL |grep -v ISurl | \
while read url isurl
do
    http_present=`echo "$isurl" | grep http:// `
    if [[ $http_present != '' ]]
    then
	url=$isurl
    fi

    anchor=`echo $url | cut -s -f2 -d#`
    file=`echo $url | cut -f1 -d#`
    dir=`dirname "$file"`
    filename=`basename "$file"`
    if [[ -s "downloaded_pages/$file" ]]
    then
	#echo "$url is already downloaded"
	echo "" > wget_errors
    else
	mkdir -p "downloaded_pages/$dir"
	wget "$url" -O downloaded_pages/$file 2>wget_errors
    fi
    
    if grep -q 404\ Not\ Found wget_errors
    then
	echo "Not Found: $url" >>erroneous_urls;
    fi
    
    if [[ $anchor != "" ]]
    then
	anchor=`echo $anchor | sed s/*/\*/`
	if ! grep -i -q \<a\ \.*name=\[\'\"\]$anchor\[\'\"\] "downloaded_pages/$file"
	then 
	    echo "Url $url: anchor $anchor is not found in the downloaded file ($file)" >>erroneous_urls
	fi
    fi
done

rm -f wget_errors
